#!/bin/sh

if [ ! -f /usr/share/common-lisp/source/defsystem/defsystem.lisp ] ; then
  cat <<EOF
$0: cannot find the defsystem source.
This can not happen, because defsystem is part of the common-lisp-controller package. 
EOF
  exit 0
fi

EXEC=/usr/bin/openmcl

case $1 in
    rebuild)
	    echo $0 rebuilding...
	    shift
	    while [ ! -z "$1" ] ; do
		echo rebuilding $1
		${EXEC} --batch <<EOF
(funcall (intern "OOS" "MAKE") :$1 :compile :verbose nil :compile-during-load t)
EOF
		shift
 	    done 
	    ;;
	    
     install-defsystem)
	    echo $0 installing defsystem
	    # if there's no clean core, move the current one to the clean one.
	    if [ ! -f /usr/lib/openmcl/PPCCL-clean ]
	    then
              mv /usr/lib/openmcl/PPCCL /usr/lib/openmcl/PPCCL-clean
            fi
	    ${EXEC} --image-name /usr/lib/openmcl/PPCCL-clean --batch <<EOF
(load "/usr/share/common-lisp/source/common-lisp-controller/common-lisp-controller.lisp")
(load "/usr/share/common-lisp/source/defsystem/defsystem.lisp")
(ccl::save-application "/usr/lib/openmcl/PPCCL" :init-file "/etc/openmclrc")
EOF
            ;;
     remove-defsystem)
            echo $0 removing defsystem
            mv /usr/lib/openmcl/PPCCL-clean /usr/lib/openmcl/PPCCL
            ;;
	    
     remove)
	    echo $0 removing packages...
	    shift
	    while [ ! -z "$1" ] ; do
		rm -rf "/usr/lib/common-lisp/openmcl/$1"
		shift
 	    done
	    ;;
    *)
	    echo $0 unkown command $1
	    echo known commands: install-defsystem, remove-defsystem, rebuild and remove
	    exit 1
	    ;;
esac

exit 0
